/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase controladora para el componente TAM_ReporteLeadsDTCtrl

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha                Autor                       Descripcion
    1.0    02-Junio-2021        Héctor Figueroa             Creación
******************************************************************************* */

public without sharing class TAM_ReporteLeadsDTCtrl {

    public class wrpListaDealersUsuarios{
        @AuraEnabled public wrpUsuario objWrpUsuarioAct {get;set;} 
        @AuraEnabled public String ledsSinAtender {get;set;} 
        @AuraEnabled public String ledsProcCita {get;set;} 
        @AuraEnabled public String ledsCitaAgenda {get;set;} 
        @AuraEnabled public String ledsCitaAsist {get;set;} 
        @AuraEnabled public String ledsNegocia {get;set;} 
        @AuraEnabled public String ledsPedido {get;set;} 
        @AuraEnabled public String ledsVenta {get;set;} 
        @AuraEnabled public String ledsActivos {get;set;} 
        @AuraEnabled public String ledsBajas {get;set;} 

        //Un contrusctor con parametros
        public wrpListaDealersUsuarios(){                
            this.objWrpUsuarioAct = new wrpUsuario();
            this.ledsSinAtender = '';
            this.ledsProcCita = '';
            this.ledsCitaAgenda = '';
            this.ledsCitaAsist = '';
            this.ledsNegocia = '';
            this.ledsPedido = '';
            this.ledsVenta = '';
            this.ledsActivos = '';
            this.ledsBajas = '';
        }//Fin si wrpListaDealers       
                
        //Un contrusctor con parametros
        public wrpListaDealersUsuarios(wrpUsuario objWrpUsuarioAct, String ledsSinAtender, String ledsProcCita,
            String ledsCitaAgenda, String ledsCitaAsist, String ledsNegocia, String ledsPedido, String ledsVenta,
            String ledsActivos, String ledsBajas){                
            this.objWrpUsuarioAct = objWrpUsuarioAct;
            this.ledsSinAtender = ledsSinAtender;
            this.ledsProcCita = ledsProcCita;
            this.ledsCitaAgenda = ledsCitaAgenda;
            this.ledsCitaAsist = ledsCitaAsist;
            this.ledsNegocia = ledsNegocia;
            this.ledsPedido = ledsPedido;
            this.ledsVenta = ledsVenta;
            this.ledsActivos = ledsActivos;
            this.ledsBajas = ledsBajas;
        }//Fin si wrpListaDealers       
    }

    public class wrpUsuario{
        @AuraEnabled public String codigo {get;set;} 
        @AuraEnabled public String nombreUsuario {get;set;} 
        @AuraEnabled public String nombreDist {get;set;} 
        @AuraEnabled public String funcionUsuario {get;set;} 
        @AuraEnabled public String idUsuario {get;set;} 
        @AuraEnabled public Boolean blnMuestraLD {get;set;} 
        @AuraEnabled public Boolean blnMuestraLUD {get;set;} 
        @AuraEnabled public List<wrpDelaer> lDealers {get;set;} 

        //Un contrusctor por default
        public wrpUsuario(){
            this.codigo = '';
            this.nombreUsuario = '';
            this.nombreDist = '';
            this.funcionUsuario = '';
            this.blnMuestraLD = false;
            this.blnMuestraLUD = false;            
            this.idUsuario = '';
            this.lDealers = new List<wrpDelaer>();
        }//Fin si wrpListaDealers
                
        //Un contrusctor con parametros
        public wrpUsuario(String codigo, String nombreUsuario, String funcionUsuario){
            this.codigo = codigo;
            this.nombreUsuario = nombreUsuario;
            this.funcionUsuario = funcionUsuario;
        }//Fin si wrpListaDealers
    }

    public class wrpDelaer{
        @AuraEnabled public String codigo {get;set;} 
        @AuraEnabled public String nombreDist {get;set;} 
        @AuraEnabled public List<wrpUsuarioDealer> lUsrDealer {get;set;} 

        //Un contrusctor por default
        public wrpDelaer(){
            this.codigo = '';
            this.nombreDist = '';
            this.lUsrDealer = new List<wrpUsuarioDealer>();
        }//Fin si wrpListaDealers
                
        //Un contrusctor con parametros
        public wrpDelaer(String codigo, String nombreDist, List<wrpUsuarioDealer> lUsrDealer){
            this.codigo = codigo;
            this.nombreDist = nombreDist;
            this.lUsrDealer = lUsrDealer;
        }//Fin si wrpListaDealers        
    }

    public class wrpUsuarioDealer{
        @AuraEnabled public String idUsuario {get;set;} 
        @AuraEnabled public String codigoDealer {get;set;}         
        @AuraEnabled public String nombreUsuario {get;set;} 

        //Un contrusctor por default
        public wrpUsuarioDealer(){
            this.idUsuario = '';
            this.codigoDealer = '';            
            this.nombreUsuario = '';
        }//Fin si wrpListaDealers
                
        //Un contrusctor con parametros
        public wrpUsuarioDealer(String idUsuario, String codigoDealer, String nombreUsuario){
            this.idUsuario = idUsuario;
            this.codigoDealer = codigoDealer;
            this.nombreUsuario = nombreUsuario;
        }//Fin si wrpListaDealers        
    }

    //Obtener getDatosCandidato.
    @AuraEnabled
    public static Boolean clsGetPerfilUserActual() {
        System.debug('En getPerfilUserActual...');
        
        //Cualquier usuario        
        Boolean bEsUserAdmin = true;
        
        System.debug('En getPerfilUserActual bEsUserAdmin: ' + bEsUserAdmin);
        return bEsUserAdmin;
    }

    //Obtener getDatosCandidato.
    @AuraEnabled
    public static wrpUsuario clsGetDatosUsuariosActual (String IdUsrActual) {
        System.debug('En hpGetDatosUsuariosActual  IdUsrActual: ' + IdUsrActual);
        String strCadenaDeBusqueda = '';
        String sCodDist;
        String sUsrRole;
        String sUsrId;
        String sUsrNomDist;
        String sNomUsr;

        Boolean blnConsEjec = false;
        Boolean blnConsGest = false;
        Boolean blnConsAsesor = false;
        Boolean blnMuestraLD = false;
        Boolean blnMuestraLUD = false;        
        Set<String> setIdGrupoColab = new Set<String>();
        Set<String> setIdUsrColab = new Set<String>();
        Set<String> setIdUsrRole = new Set<String>();
        Set<String> setNomUsrRole = new Set<String>();
        Set<String> setIdUsrfinal = new Set<String>();
        Map<String, List<TAM_UsuariosSeguimientoLead__c>> mapCodDealerObjUsr = new Map<String, List<TAM_UsuariosSeguimientoLead__c>>();        
        Map<String, String> mapCodDealerNom = new Map<String, String>();        
        wrpUsuario objwrpUsuario = new wrpUsuario();
               
        //Busca el Role en el portal
        for (User usuarioActual : [Select id, CodigoDistribuidor__c, UserRoleId, UserRole.PortalRole 
            From User Where Id =:UserInfo.getUserId() ]){
            sCodDist = usuarioActual.CodigoDistribuidor__c;
            sUsrRole = usuarioActual.UserRole.PortalRole;
            sUsrId = Test.isRunningTest() ? IdUsrActual : UserInfo.getUserId();   
        }
        System.debug('En hpGetDatosUsuariosActual  sCodDist: ' + sCodDist + ' sUsrRole: ' + sUsrRole + ' sUsrId: ' + sUsrId);
        
        for (Account objDist : [Select id, Name From Account Where Codigo_Distribuidor__c =:sCodDist ]){
            sUsrNomDist = objDist.Name;
        }
        //Es una prueba
        if (Test.isRunningTest())
           sUsrNomDist = 'Toyota Innova Fleteros'; 
        System.debug('En hpGetDatosUsuariosActual  sCodDist: ' + sCodDist + ' sUsrRole: ' + sUsrRole + ' sUsrId: ' + sUsrId + ' sUsrNomDist: ' + sUsrNomDist);
        
        blnConsEjec = sUsrRole == 'Executive' ? true : false;
        blnConsGest = sUsrRole == 'Manager' ? true : false;
        blnConsAsesor = sUsrRole == 'Worker' ? true : false;
        
        List<wrpListaDealersUsuarios> lWrpListaDealersUsuarios = new List<wrpListaDealersUsuarios>();
        Map<String, wrpListaDealersUsuarios> mapNomUsrWrpsuario = new Map<String, wrpListaDealersUsuarios>();

        //Consulta todos los usuarios asociados al Delaer.
        if (sCodDist == null)
            sCodDist = '57000';

        //Se trata del asesro solo ve lo de el
        if (blnConsAsesor || Test.isRunningTest()){
            //Comstlua los usuaros asociados al Distrbuidor en el objeto de TAM_UsuariosSeguimientoLead__c
            for (TAM_UsuariosSeguimientoLead__c objUsr : [select id, Name, TAM_NoDistribuidor__c, TAM_IdUsuarioPartner__c,
                TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c, TAM_NombreDistribuidor__c 
                 From TAM_UsuariosSeguimientoLead__c Where TAM_IdUsuarioPartner__c =:sUsrId
                 And TAM_ActivoSFDC__c = true Order by Name]){
               //Inicializa el nombre del usuario      
               if (sUsrId == objUsr.TAM_IdUsuarioPartner__c)
                    sNomUsr = objUsr.TAM_NombreCompleto__c;
               //Metelo al mapa de mapCodDealerObjUsr
               if (mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsr.get(objUsr.TAM_NoDistribuidor__c).add(objUsr);               
               if (!mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsr.put(objUsr.TAM_NoDistribuidor__c, new List<TAM_UsuariosSeguimientoLead__c>{objUsr});
            }            
        }//Fin si blnConsAsesor
                
        //Se trata del gestor solo ve lo de su Dealer
        if (blnConsGest || Test.isRunningTest()){
            blnMuestraLUD = true;            
            //Comstlua los usuaros asociados al Distrbuidor en el objeto de TAM_UsuariosSeguimientoLead__c
            for (TAM_UsuariosSeguimientoLead__c objUsr : [select id, Name, TAM_NoDistribuidor__c, TAM_IdUsuarioPartner__c,
                TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c, TAM_NombreDistribuidor__c  
                 From TAM_UsuariosSeguimientoLead__c Where TAM_NoDistribuidor__c = :sCodDist 
                 And TAM_ActivoSFDC__c = true Order by Name]){
               //Inicializa el nombre del usuario      
               if (sUsrId == objUsr.TAM_IdUsuarioPartner__c)
                    sNomUsr = objUsr.TAM_NombreCompleto__c;
               //Metelo al mapa de mapCodDealerObjUsr
               if (mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsr.get(objUsr.TAM_NoDistribuidor__c).add(objUsr);               
               if (!mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
                   mapCodDealerObjUsr.put(objUsr.TAM_NoDistribuidor__c, new List<TAM_UsuariosSeguimientoLead__c>{objUsr});
            }            
        }//Fin si blnConsGest

        //Se trata del ejecutivo y tal vez tenga una colaboración especial
        if (blnConsEjec || Test.isRunningTest()){
            blnMuestraLD = true;
            blnMuestraLUD = true;        
            
            //Consulta todos los Delaer relasionados en el gripo de 
            String sNomGrupoCol = sUsrNomDist.replace('Toyota', 'Grupo') + ' ' + sCodDist + ' Colabora'; //Toyota Innova Fleteros
            System.debug('En clsGetDatosUsuariosActual  sNomGrupoCol: ' + sNomGrupoCol);
            //Ve por los miembros del grupo            
            for (GroupMember grupoMemDealerColabora : [Select g.UserOrGroupId, g.GroupId, g.Group.Name 
                From GroupMember g Where g.Group.Name =: sNomGrupoCol]){
                System.debug('En clsGetDatosUsuariosActual  grupoMemDealerColabora: ' + grupoMemDealerColabora);
                String sIdUsrGrp = grupoMemDealerColabora.UserOrGroupId;
                if (sIdUsrGrp.startsWith('00G'))
                    setIdGrupoColab.add(grupoMemDealerColabora.UserOrGroupId);
                if (sIdUsrGrp.startsWith('005'))
                    setIdUsrColab.add(grupoMemDealerColabora.UserOrGroupId);
            }//Fin del for para GroupMember
            //Si no existe en grupo asociado al Delaer del usuario enonces desactiva la bandera de blnMuestraLD
            //if (!Test.isRunningTest()){
            if (setIdGrupoColab.isEmpty()){
                blnMuestraLD = false;
                blnConsGest = true;
                sUsrRole = 'Manager';
		        //Comstlua los usuaros asociados al Distrbuidor en el objeto de TAM_UsuariosSeguimientoLead__c
		        for (TAM_UsuariosSeguimientoLead__c objUsr : [select id, Name, TAM_NoDistribuidor__c, TAM_IdUsuarioPartner__c,
		            TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c, TAM_NombreDistribuidor__c  
		            From TAM_UsuariosSeguimientoLead__c Where TAM_NoDistribuidor__c = :sCodDist 
		            And TAM_ActivoSFDC__c = true Order by Name]){
		            //Inicializa el nombre del usuario      
		            if (sUsrId == objUsr.TAM_IdUsuarioPartner__c)
		                    sNomUsr = objUsr.TAM_NombreCompleto__c;
		            //Metelo al mapa de mapCodDealerObjUsr
		            if (mapCodDealerObjUsr.containsKey(sCodDist))
		                mapCodDealerObjUsr.get(sCodDist).add(objUsr);               
		            if (!mapCodDealerObjUsr.containsKey(sCodDist))
		                mapCodDealerObjUsr.put(sCodDist, new List<TAM_UsuariosSeguimientoLead__c>{objUsr});
		        }//Fin el for para TAM_UsuariosSeguimientoLead__c
            }//Fin si setIdGrupoColab.isEmpty()
            //}//Fin si !Test.isRunningTest()            
            System.debug('En clsGetDatosUsuariosActual  setIdGrupoColab: ' + setIdGrupoColab);
            System.debug('En clsGetDatosUsuariosActual  setIdUsrColab: ' + setIdUsrColab);
            System.debug('En clsGetDatosUsuariosActual  blnMuestraLD: ' + blnMuestraLD);
            System.debug('En clsGetDatosUsuariosActual  mapCodDealerObjUsr: ' + mapCodDealerObjUsr.keySet());
            System.debug('En clsGetDatosUsuariosActual  mapCodDealerObjUsr: ' + mapCodDealerObjUsr.Values());
            
            //Consulta los datos de los grupos asociados a setIdGrupoColab
            for (Group usrGrupDealerColabora : [Select g.id, g.RelatedId, g.Name 
                From Group g Where id IN: setIdGrupoColab]){
                System.debug('En clsGetDatosUsuariosActual  usrGrupDealerColabora: ' + usrGrupDealerColabora);
                String sIdUsrGrp = usrGrupDealerColabora.RelatedId;
                if (sIdUsrGrp.startsWith('00E'))
                    setIdUsrRole.add(usrGrupDealerColabora.RelatedId);
                if (sIdUsrGrp.startsWith('005'))
                    setIdUsrColab.add(usrGrupDealerColabora.RelatedId);
            }//Fin del for para GroupMember
            System.debug('En clsGetDatosUsuariosActual  setIdUsrRole: ' + setIdUsrRole);
            System.debug('En clsGetDatosUsuariosActual  setIdUsrColab2: ' + setIdUsrColab);

            //Consulta los usuarios a los roles en setIdUsrRole
            for (UserRole objUserRole : [Select id, Name From UserRole u Where ID IN :setIdUsrRole]){
                //Mete el nombre del Rol en el set de setNomUsrRole
                setNomUsrRole.add(objUserRole.Name);
                System.debug('En clsGetDatosUsuariosActual  objUserRole: ' + objUserRole.Name);
            }
            //Agrega a los que corresponen con el dealer actual del usuario 
            setNomUsrRole.add(sUsrNomDist + ' Socio Ejecutivo'); //Toyota Innova Fleteros Socio Ejecutivo
            setNomUsrRole.add(sUsrNomDist + ' Socio Gestor'); //Toyota Innova Fleteros Socio Gestor
            setNomUsrRole.add(sUsrNomDist + ' Socio Usuario'); //Toyota Innova Fleteros Socio Usuario
            System.debug('En clsGetDatosUsuariosActual  setNomUsrRole: ' + setNomUsrRole);

            //Consulta los usuarios asociados a setIdUsrColab
            for (User objUsr : [Select id, Distribuidor__c, CodigoDistribuidor__c From User
               where UserRole.Name IN :setNomUsrRole And UserLicenseName__c = 'Partner Community']){
                System.debug('En clsGetDatosUsuariosActual  objUsr: ' + objUsr);
                //Metelo al mapa de 
                setIdUsrfinal.add(objUsr.id);
            }//Fin del for para User 
            //Agrega al usuario actual 
            setIdUsrfinal.add(sUsrId);
            System.debug('En clsGetDatosUsuariosActual  setIdUsrfinal: ' + setIdUsrfinal);
            
            //Comstlua los usuaros asociados al Distrbuidor en el objeto de TAM_UsuariosSeguimientoLead__c
            for (TAM_UsuariosSeguimientoLead__c objUsr : [select id, Name, TAM_NoDistribuidor__c, TAM_IdUsuarioPartner__c,
                TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c, TAM_NombreDistribuidor__c  
                 From TAM_UsuariosSeguimientoLead__c Where TAM_IdUsuarioPartner__c IN :setIdUsrfinal 
                 And TAM_ActivoSFDC__c = true Order by Name]){
               //Inicializa el nombre del usuario      
               if (sUsrId == objUsr.TAM_IdUsuarioPartner__c)
                    sNomUsr = objUsr.TAM_NombreCompleto__c;      
               //Metelo al mapa de mapCodDealerObjUsr
               if (blnMuestraLD){
	               if (mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
	                   mapCodDealerObjUsr.get(objUsr.TAM_NoDistribuidor__c).add(objUsr);               
	               if (!mapCodDealerObjUsr.containsKey(objUsr.TAM_NoDistribuidor__c))
	                   mapCodDealerObjUsr.put(objUsr.TAM_NoDistribuidor__c, new List<TAM_UsuariosSeguimientoLead__c>{objUsr});
               }//Fin si blnMuestraLD
            }//Fin del for para TAM_UsuariosSeguimientoLead__c
        }//Fin si blnConsEjec
        System.debug('En clsGetDatosUsuariosActual  mapCodDealerObjUsr: ' + mapCodDealerObjUsr.values());
        System.debug('En clsGetDatosUsuariosActual  mapCodDealerObjUsr: ' + mapCodDealerObjUsr.values());       
        System.debug('En clsGetDatosUsuariosActual  sNomUsr: ' + sNomUsr);
        System.debug('En clsGetDatosUsuariosActual  blnMuestraLD: ' + blnMuestraLD);
        System.debug('En clsGetDatosUsuariosActual  blnMuestraLUD: ' + blnMuestraLUD);
        
        Set<String> setCodGrupoNom = new Set<String>();
        //Recorre el mapa de mapNomUsrWrpsuario y llena el objeto de objwrpUsuario
        for (String sCodDeal : mapCodDealerObjUsr.keyset()){
            for (TAM_UsuariosSeguimientoLead__c objPaso : mapCodDealerObjUsr.get(sCodDeal)){
                setCodGrupoNom.add(sCodDeal + ' - ' + objPaso.TAM_NombreDistribuidor__c);    
            }
        }
        System.debug('En clsGetDatosUsuariosActual  setCodGrupoNom: ' + setCodGrupoNom);       
        
        List<wrpDelaer> lDealers = new List<wrpDelaer>();
        for (String sCodDealer : setCodGrupoNom){
            System.debug('En clsGetDatosUsuariosActual  sCodDealer: ' + sCodDealer);
            List<wrpUsuarioDealer> lUsrDealers = new List<wrpUsuarioDealer>();            
            String[] lDatosDealer = sCodDealer.split(' - ');
            System.debug('En clsGetDatosUsuariosActual  lDatosDealer: ' + lDatosDealer);
            //Recorre el mapa de mapCodDealerObjUsr y toma los usuarios del dist
            for (TAM_UsuariosSeguimientoLead__c objPaso : mapCodDealerObjUsr.get(lDatosDealer[0])){
                lUsrDealers.add(new wrpUsuarioDealer(objPaso.TAM_IdUsuarioPartner__c, sCodDealer, objPaso.TAM_NombreCompleto__c));
            }//Fin del for para mapCodDealerObjUsr.get(lDatosDealer[0])
            System.debug('En clsGetDatosUsuariosActual  lUsrDealers: ' + lUsrDealers);
            //Llena la lista de lDealers  
            lDealers.add(new wrpDelaer(lDatosDealer[0], lDatosDealer[1], lUsrDealers));
        }
        System.debug('En clsGetDatosUsuariosActual  lDealers: ' + lDealers);
        //Inicializa el objeto de objwrpUsuario        
        objwrpUsuario = new wrpUsuario(sCodDist, sNomUsr, sUsrRole);
        objwrpUsuario.idUsuario = sUsrId;
        objwrpUsuario.nombreDist = sUsrNomDist;                
        objwrpUsuario.blnMuestraLD = blnMuestraLD;                
        objwrpUsuario.blnMuestraLUD = blnMuestraLUD;
        objwrpUsuario.lDealers = lDealers;        
        System.debug('En clsGetDatosUsuariosActual objwrpUsuario: ' + objwrpUsuario);
                          
        //Regresa la lista de Dealers
        return objwrpUsuario;
    }

    //Obtener getDatosCandidato.
    @AuraEnabled
    public static List<wrpUsuarioDealer> clsGetListaUsr(String codDealerPrm
        , wrpUsuario objWrpUsuarioPrm) {
        System.debug('En clsGetListaUsr  codDealerPrm: ' + codDealerPrm);
        System.debug('En clsGetListaUsr  objWrpUsuarioPrm: ' + objWrpUsuarioPrm);

        List<wrpUsuarioDealer> lWrpListaDealersUsuarios = new List<wrpUsuarioDealer>();

        //Ya tienes el objeto del tipo wrpUsuario dale vuelta a los Dealers y busca el de codDealerPrm
        for (wrpDelaer objWrpDelaer : objWrpUsuarioPrm.lDealers){
            //Ve si objWrpDelaer.codigo == codDealerPrm
            if (objWrpDelaer.codigo == codDealerPrm){
                //Toma la lista de usuarios del delaer y metelos a la lista de lWrpListaDealersUsuarios
                for (wrpUsuarioDealer objWrpUsuarioDealer :objWrpDelaer.lUsrDealer){
                    lWrpListaDealersUsuarios.add(objWrpUsuarioDealer);
                }
                break;    
            }//Fin si 
        }//Fin del for para objWrpUsuarioPrm.lDealers

        System.debug('En clsGetListaUsr  lWrpListaDealersUsuarios: ' + lWrpListaDealersUsuarios);
        return lWrpListaDealersUsuarios;
    }

    //Obtener getDatosCandidato.
    @AuraEnabled
    public static List<wrpListaDealersUsuarios> clsBuscaTotPorUsuario(String IdUsrActual
        , wrpUsuario objWrpUsuarioPrm, String sCodDealerSelPrm, String sIdUsrSelPrm
        , String dtFechaInicioBusPrm, String dtFechaFinBusPrm, String sMesSelPrm) {
        System.debug('En clsBuscaTotPorUsuario  IdUsrActual: ' + IdUsrActual + ' sCodDealerSelPrm: ' + sCodDealerSelPrm + ' sIdUsrSelPrm: ' + sIdUsrSelPrm + ' dtFechaInicioBusPrm: ' + dtFechaInicioBusPrm + ' dtFechaFinBusPrm: ' + dtFechaFinBusPrm + ' sMesSelPrm: ' + sMesSelPrm);
        System.debug('En clsBuscaTotPorUsuario  objWrpUsuarioPrm: ' + objWrpUsuarioPrm);
        
        Boolean blnConsEjec = false;
        Boolean blnConsGest = false;
        Boolean blnConsAsesor = false;
                       
        String sCodDist = objWrpUsuarioPrm.codigo;    
        String sRole = objWrpUsuarioPrm.funcionUsuario; 
        String sUsrNom = objWrpUsuarioPrm.nombreUsuario.toUpperCase();
        String sIdUsuario = objWrpUsuarioPrm.idUsuario;
        String sNomDist = objWrpUsuarioPrm.nombreDist;
        String strDtFechaInicioBusFin = dtFechaInicioBusPrm + 'T00:00:00Z';
        String[] lDtFechaInicioBusFin = dtFechaFinBusPrm != null ? dtFechaFinBusPrm.split('-') : new List<String>();
        DateTime dtmFechaFinBusPaso = (dtFechaFinBusPrm != null && dtFechaFinBusPrm != '') ? ( DateTime.newInstance(Integer.valueOf(lDtFechaInicioBusFin[0]), Integer.valueOf(lDtFechaInicioBusFin[1]), Integer.valueOf(lDtFechaInicioBusFin[2]), 0, 0, 0) ) : Datetime.now();
        DateTime dtFechaFinBusFin = dtmFechaFinBusPaso.addDays(1).addHours(5);
        String strDtFechaFinBusFin = String.valueOf(dtFechaFinBusFin).replace(' ', 'T') + 'Z';

        //Especial para las ventas
        String strDtFechaInicioBusFinVta = strDtFechaInicioBusFin;
        String strDtFechaFinBusFinVta = strDtFechaFinBusFin;
                
        //Va a consultar por mes
        if (sMesSelPrm != 'Mes actual' && sMesSelPrm != 'Mes anterior' && sMesSelPrm != 'Ultimos 3 meses'){
            strDtFechaInicioBusFin = dtFechaInicioBusPrm;
            Date dtFechaFinBusFinPaso = dtFechaFinBusPrm != null ? ( Date.newInstance(Integer.valueOf(lDtFechaInicioBusFin[0]), Integer.valueOf(lDtFechaInicioBusFin[1]), Integer.valueOf(lDtFechaInicioBusFin[2])) ) : Date.today();
            strDtFechaFinBusFin = String.valueOf(dtFechaFinBusFinPaso);
        }//Fin si sMesSelPrm != 'Mes actual' && sMesSelPrm != 'Mes anterior' && sMesSelPrm != 'Ultimos 3 meses'
        
        //Va a consultar por mes
        if (sMesSelPrm == 'Mes actual' || sMesSelPrm == 'Mes anterior' || sMesSelPrm == 'Ultimos 3 meses'){
            Date dtFechaAct = Date.today();
            DateTime dtFechaHoraAct = DateTime.newInstance(dtFechaAct.year(), dtFechaAct.month(), dtFechaAct.day(), 0, 0, 0); 
            if (sMesSelPrm == 'Mes actual'){
                Date dtFechaIniCond = Date.newInstance(dtFechaAct.year(), dtFechaAct.month(), 1); 
                strDtFechaInicioBusFin = String.valueOf(dtFechaIniCond);
                strDtFechaFinBusFin = String.valueOf(dtFechaAct);

                strDtFechaInicioBusFinVta = strDtFechaInicioBusFin + 'T00:00:00Z';
                dtFechaFinBusFin = dtFechaHoraAct.addDays(1).addHours(5);
                String strDtFechaFinBusFinPasoVta = String.valueOf(dtFechaFinBusFin).replace(' ', 'T') + 'Z';
                strDtFechaFinBusFinVta = strDtFechaFinBusFinPasoVta;
            }//Fin si sMesSelPrm == 'Mes actual'
            if (sMesSelPrm == 'Mes anterior'){
                Date dtFechaFinBusFinPaso = Date.newInstance(dtFechaAct.year(), dtFechaAct.month(), 1); 
                Date dtFechaFinBusFinCons = dtFechaFinBusFinPaso.addDays(-1);
                
                Date dtFechaIniBusPaso = dtFechaFinBusFinPaso.addMonths(-1);
                Date dtFechaIniBus = Date.newInstance(dtFechaIniBusPaso.year(), dtFechaIniBusPaso.month(), 1); 
                                
                strDtFechaInicioBusFin = String.valueOf(dtFechaIniBus);
                strDtFechaFinBusFin = String.valueOf(dtFechaFinBusFinCons);
                
                //Para la venta
                strDtFechaInicioBusFinVta = strDtFechaInicioBusFin + 'T00:00:00Z';
                dtFechaHoraAct = DateTime.newInstance(dtFechaFinBusFinCons.year(), dtFechaFinBusFinCons.month(), dtFechaFinBusFinCons.day(), 0, 0, 0);                 
                dtFechaFinBusFin = dtFechaHoraAct.addDays(1).addHours(5);
                String strDtFechaFinBusFinPasoVta = String.valueOf(dtFechaFinBusFin).replace(' ', 'T') + 'Z';
                strDtFechaFinBusFinVta = strDtFechaFinBusFinPasoVta;
            }//Fin si sMesSelPrm == 'Mes anterior'
            if (sMesSelPrm == 'Ultimos 3 meses'){
                Integer intMesAtras = -2;
                Date dtFechaActPaso =  dtFechaAct.addMonths(intMesAtras);
                Date dtFechaIniBus = Date.newInstance(dtFechaActPaso.year(), dtFechaActPaso.Month(), 1); 
                                
                strDtFechaInicioBusFin = String.valueOf(dtFechaIniBus);
                strDtFechaFinBusFin = String.valueOf(Date.today());

                //Para la venta
                strDtFechaInicioBusFinVta = strDtFechaInicioBusFin + 'T00:00:00Z';
                dtFechaHoraAct = DateTime.newInstance(dtFechaAct.year(), dtFechaAct.month(), dtFechaAct.day(), 0, 0, 0);                 
                dtFechaFinBusFin = dtFechaHoraAct.addDays(1).addHours(5);
                String strDtFechaFinBusFinPasoVta = String.valueOf(dtFechaFinBusFin).replace(' ', 'T') + 'Z';
                strDtFechaFinBusFinVta = strDtFechaFinBusFinPasoVta;
            }//Fin si sMesSelPrm == 'Mes anterior'
        }//Fin si sMesSelPrm == 'Mes actual' || sMesSelPrm == 'Mes anterior' || sMesSelPrm == 'Ultimos 3 meses'
        
        System.debug('En clsBuscaTotPorUsuario  sCodDist: ' + sCodDist + ' sRole: ' + sRole + ' sUsrNom: ' + sUsrNom + ' sIdUsuario: ' + sIdUsuario + ' sNomDist: ' + sNomDist);
        System.debug('En clsBuscaTotPorUsuario  strDtFechaInicioBusFin0: ' + strDtFechaInicioBusFin + ' strDtFechaFinBusFin: ' + strDtFechaFinBusFin);
        System.debug('En clsBuscaTotPorUsuario  strDtFechaInicioBusFinVta: ' + strDtFechaInicioBusFinVta + ' strDtFechaFinBusFinVta: ' + strDtFechaFinBusFinVta);
        
        blnConsEjec = sRole == 'Executive' ? true : false;
        blnConsGest = sRole == 'Manager' ? true : false;
        blnConsAsesor = sRole == 'Worker' ? true : false;
        System.debug('En clsBuscaTotPorUsuario  blnConsEjec: ' + blnConsEjec + ' blnConsGest: ' + blnConsGest + ' blnConsAsesor: ' + blnConsAsesor);
        
        List<wrpListaDealersUsuarios> lWrpListaDealersUsuarios = new List<wrpListaDealersUsuarios>();
        Map<String, wrpListaDealersUsuarios> mapNomUsrWrpsuario = new Map<String, wrpListaDealersUsuarios>();
        Map<String, List<TAM_UsuariosSeguimientoLead__c>> mapCodDealerObjUsr = new Map<String, List<TAM_UsuariosSeguimientoLead__c>>();

        //Consulta todos los usuarios asociados al Delaer.
        if (sCodDist == null)
            sCodDist = '57000';
        
        Set<String> setIdUsrs = new Set<String>();        
        //Asesor
        if (blnConsAsesor || Test.isRunningTest()){
            sCodDealerSelPrm = sCodDist;
            //Ya tienes el objeto del tipo wrpUsuario dale vuelta a los Dealers y busca el de codDealerPrm
            for (wrpDelaer objWrpDelaer : objWrpUsuarioPrm.lDealers){
                //Ve si objWrpDelaer.codigo == codDealerPrm
                if (objWrpDelaer.codigo == sCodDist){
                   //Toma la lista de usuarios del delaer y metelos a la lista de lWrpListaDealersUsuarios
                   for (wrpUsuarioDealer objWrpUsuarioDealer :objWrpDelaer.lUsrDealer){
                       //Ve si el sIdUsrSelPrm es igual al  objWrpUsuarioDealer.idUsuario
                       if (objWrpUsuarioDealer.idUsuario == sIdUsuario)
                          setIdUsrs.add(objWrpUsuarioDealer.idUsuario);
                   }
                }//Fin si objWrpDelaer.codigo == codDealerPrm
            }//Fin del for para objWrpUsuarioPrm.lDealers
        }//Fin si blnConsAsesor
        
        //Gestor
        if (blnConsGest || Test.isRunningTest()){
            //Ya tienes el objeto del tipo wrpUsuario dale vuelta a los Dealers y busca el de codDealerPrm
            for (wrpDelaer objWrpDelaer : objWrpUsuarioPrm.lDealers){
                //Ve si objWrpDelaer.codigo == codDealerPrm
                if (objWrpDelaer.codigo == sCodDist){
                    //Ve si selecciono todos los usuarios o uno en particular
                    if (sIdUsrSelPrm == '57999'){
                        //Toma la lista de usuarios del delaer y metelos a la lista de lWrpListaDealersUsuarios
                        for (wrpUsuarioDealer objWrpUsuarioDealer :objWrpDelaer.lUsrDealer){
                            setIdUsrs.add(objWrpUsuarioDealer.idUsuario);
                        }
                    }//Fin si sIdUsrSelPrm == '57999'
                    if (sIdUsrSelPrm != '57999'){
                        //Toma la lista de usuarios del delaer y metelos a la lista de lWrpListaDealersUsuarios
                        for (wrpUsuarioDealer objWrpUsuarioDealer :objWrpDelaer.lUsrDealer){
                            //Ve si el sIdUsrSelPrm es igual al  objWrpUsuarioDealer.idUsuario
                            if (sIdUsrSelPrm == objWrpUsuarioDealer.idUsuario)
                               setIdUsrs.add(objWrpUsuarioDealer.idUsuario);
                        }
                    }//Fin si sIdUsrSelPrm == '57999'
                }//Fin si objWrpDelaer.codigo == codDealerPrm
            }//Fin del for para objWrpUsuarioPrm.lDealers            
        }//Fin si blnConsGest
        
        //Ejecutivo
        if (blnConsEjec || Test.isRunningTest()){
	        //Ya tienes el objeto del tipo wrpUsuario dale vuelta a los Dealers y busca el de codDealerPrm
	        for (wrpDelaer objWrpDelaer : objWrpUsuarioPrm.lDealers){
	            if (sCodDealerSelPrm == '57999'){
	                //Ve si selecciono a todos los usuarios
	                if (sIdUsrSelPrm == '57999'){
		                //Toma la lista de usuarios del delaer y metelos a la lista de lWrpListaDealersUsuarios
		                for (wrpUsuarioDealer objWrpUsuarioDealer :objWrpDelaer.lUsrDealer){
		                    setIdUsrs.add(objWrpUsuarioDealer.idUsuario);
		                }
	                }//Fin si sIdUsrSelPrm == '57999'
                    //Ve si selecciono a todos los usuarios
                    if (sIdUsrSelPrm != '57999'){
                        //Toma la lista de usuarios del delaer y metelos a la lista de lWrpListaDealersUsuarios
                        for (wrpUsuarioDealer objWrpUsuarioDealer :objWrpDelaer.lUsrDealer){
                            //Ve si el sIdUsrSelPrm es igual al  objWrpUsuarioDealer.idUsuario
                            if (sIdUsrSelPrm == objWrpUsuarioDealer.idUsuario)
                                setIdUsrs.add(objWrpUsuarioDealer.idUsuario);
                        }
                    }//Fin si sIdUsrSelPrm == '57999'
	            }//Fin si sCodDealerSelPrm == '57999'
                if (sCodDealerSelPrm != '57999'){
	                //Ve si objWrpDelaer.codigo == codDealerPrm
	                if (objWrpDelaer.codigo == sCodDealerSelPrm){
	                    //Ve si selecciono todos los usuarios o uno en particular
	                    if (sIdUsrSelPrm == '57999'){
	                        //Toma la lista de usuarios del delaer y metelos a la lista de lWrpListaDealersUsuarios
	                        for (wrpUsuarioDealer objWrpUsuarioDealer :objWrpDelaer.lUsrDealer){
	                            setIdUsrs.add(objWrpUsuarioDealer.idUsuario);
	                        }
	                    }//Fin si sIdUsrSelPrm == '57999'
	                    if (sIdUsrSelPrm != '57999'){
                            System.debug('En clsBuscaTotPorUsuario VAL 4 objWrpUsuarioPrm: ' + objWrpUsuarioPrm + ' blnConsEjec: ' + blnConsEjec);
	                        //Toma la lista de usuarios del delaer y metelos a la lista de lWrpListaDealersUsuarios
	                        for (wrpUsuarioDealer objWrpUsuarioDealer :objWrpDelaer.lUsrDealer){
	                            //Ve si el sIdUsrSelPrm es igual al  objWrpUsuarioDealer.idUsuario
	                            if (sIdUsrSelPrm == objWrpUsuarioDealer.idUsuario)
	                                setIdUsrs.add(objWrpUsuarioDealer.idUsuario);
	                        }
	                    }//Fin si sIdUsrSelPrm == '57999'
	                }//Fin si objWrpDelaer.codigo == codDealerPrm
                }//Fin si sCodDealerSelPrm != '57999'
	        }//Fin del for para objWrpUsuarioPrm.lDealers
        }//Fin si blnConsEjec
        System.debug('EN clsBuscaTotPorUsuario setIdUsrs: ' + setIdUsrs);
        System.debug('EN clsBuscaTotPorUsuario sCodDealerSelPrm: ' + sCodDealerSelPrm);
        
        //Comstlua los usuaros asociados al Distrbuidor en el objeto de TAM_UsuariosSeguimientoLead__c
        for (TAM_UsuariosSeguimientoLead__c objUsrSegLead : [select id, Name, TAM_NoDistribuidor__c, 
            TAM_Activo__c, TAM_IdExterno__c, TAM_ActivoSFDC__c, TAM_NombreCompleto__c 
            From TAM_UsuariosSeguimientoLead__c Where TAM_IdUsuarioPartner__c IN :setIdUsrs
            And TAM_ActivoSFDC__c = true Order by Name]){
            //Mete al usuaro al mapa de mapNomUsrWrpsuario
            String sNomUsr = objUsrSegLead.TAM_NombreCompleto__c != NULL ? objUsrSegLead.TAM_NombreCompleto__c.toUpperCase() : '';
            //Para cualquier perfil
            if (sNomUsr != '')
                mapNomUsrWrpsuario.put(sNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(objUsrSegLead.TAM_NoDistribuidor__c, objUsrSegLead.TAM_NombreCompleto__c.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                    '', '', '', '', '', '', '', '', ''));            
        }
        System.debug('EN clsBuscaTotPorUsuario mapNomUsrWrpsuario: ' + mapNomUsrWrpsuario.keyset());
        System.debug('EN clsBuscaTotPorUsuario mapNomUsrWrpsuario: ' + mapNomUsrWrpsuario.values());

        System.debug('En clsBuscaTotPorUsuario  strDtFechaInicioBusFin1: ' + strDtFechaInicioBusFin + ' strDtFechaFinBusFin: ' + strDtFechaFinBusFin);  
        Set<String> setNomUsr = new Set<String>{'TFS ADMIN'};
        String sLUsersCons = '(';     
        //Recorre la lista de lClientes
        for (String sTipoInv : mapNomUsrWrpsuario.keySet()){ //setNomUsr
            sLUsersCons += '\'' + sTipoInv.trim() + '\',';
        }
        sLUsersCons = sLUsersCons.substring(0, sLUsersCons.lastIndexOf(','));
        sLUsersCons += ')';
        System.debug('EN EN clsBuscaTotPorUsuario sLUsersCons: ' + sLUsersCons);

        String queryledsSinAtender = 'SELECT TAM_NomPropKban__c, COUNT(ID) totLedsSinAtender' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaCreacionFormula__c >= ' + strDtFechaInicioBusFin + ' And TAM_FechaCreacionFormula__c <= ' + strDtFechaFinBusFin + '' + //CreatedDate
            ' And Status = \'Nuevo Prospecto\'' +
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +
            ' Group By TAM_NomPropKban__c';
        if (Test.isRunningTest())    
            queryledsSinAtender = 'SELECT TAM_NomPropKban__c, COUNT(ID) totLedsSinAtender' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';

        System.debug('EN clsBuscaTotPorUsuario sledsSinAtender: ' + queryledsSinAtender);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsSinAtender)){         
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decledsSinAtender = (Decimal) aggrCodDist.get('totLedsSinAtender');
            System.debug('EN ledsSinAtender sIdNomUsr: ' + sIdNomUsr + ' decledsSinAtender: ' + decledsSinAtender);
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsSinAtender = String.valueOf(decledsSinAtender);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                String.valueOf(decledsSinAtender), '', '', '', '', '', '', '', ''));
        }
        //System.debug('EN clsBuscaTotPorUsuario mapNomUsrWrpsuario: ' + mapNomUsrWrpsuario.keyset());        
        //System.debug('EN clsBuscaTotPorUsuario mapNomUsrWrpsuario: ' + mapNomUsrWrpsuario.values());        

        String queryledsProcCita = 'SELECT TAM_NomPropKban__c, COUNT(ID) totLedsProcCita' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaCreacionFormula__c >= ' + strDtFechaInicioBusFin + ' And TAM_FechaCreacionFormula__c <= ' + strDtFechaFinBusFin + '' +
            ' And (Status = \'Lead por contactar\' OR Status = \'Lead contactado\')' +
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +
            ' Group By TAM_NomPropKban__c'; 
        if (Test.isRunningTest())    
            queryledsProcCita = 'SELECT TAM_NomPropKban__c, COUNT(ID) totLedsProcCita' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';
        //Todos los candidatos agrupados por ledsProcCita
        /*for (AggregateResult aggrCodDist : [ SELECT TAM_NomPropKban__c, COUNT(ID) totLedsProcCita
            FROM Lead Where TAM_NomPropKban__c IN :mapNomUsrWrpsuario.keySet() And TAM_NomPropKban__c != null
            And (Status = 'Lead por contactar' OR Status = 'Lead contactado')
            Group By TAM_NomPropKban__c]){*/
        System.debug('EN clsBuscaTotPorUsuario queryledsProcCita: ' + queryledsProcCita);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsProcCita)){                
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decLedsProcCita = (Decimal) aggrCodDist.get('totLedsProcCita');
            System.debug('EN ledsProcCita sIdNomUsr: ' + sIdNomUsr + ' decLedsProcCita: ' + decLedsProcCita);            
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsProcCita = String.valueOf(decLedsProcCita);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                '', String.valueOf(decLedsProcCita), '', '', '', '', '', '', ''));                
        }

        String queryledsCitaAgenda = 'SELECT TAM_NomPropKban__c, COUNT(ID) totLedsCitaAgenda' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaCreacionFormula__c >= ' + strDtFechaInicioBusFin + ' And TAM_FechaCreacionFormula__c <= ' + strDtFechaFinBusFin + '' +
            ' And (Status = \'Cita agendada\')' +
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +            
            ' Group By TAM_NomPropKban__c';
        if (Test.isRunningTest())    
            queryledsCitaAgenda = 'SELECT TAM_NomPropKban__c, COUNT(ID) totLedsCitaAgenda' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';            
        //Todos los candidatos agrupados por ledsCitaAgenda
        /*for (AggregateResult aggrCodDist : [ SELECT TAM_NomPropKban__c, COUNT(ID) totLedsCitaAgenda
            FROM Lead Where TAM_NomPropKban__c IN :mapNomUsrWrpsuario.keySet() And TAM_NomPropKban__c != null
            And (Status = 'Cita agendada')
            Group By TAM_NomPropKban__c]){*/
        System.debug('EN clsBuscaTotPorUsuario queryledsCitaAgenda: ' + queryledsCitaAgenda);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsCitaAgenda)){                
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decLedsCitaAgenda = (Decimal) aggrCodDist.get('totLedsCitaAgenda');
            System.debug('EN ledsCitaAgenda sIdNomUsr: ' + sIdNomUsr + ' decLedsProcCita: ' + decLedsCitaAgenda);            
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsCitaAgenda = String.valueOf(decLedsCitaAgenda);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                '', '', String.valueOf(decLedsCitaAgenda), '', '', '', '', '', ''));                
        }

        String queryledsCitaAsist = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsCitaAsist' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaCreacionFormula__c >= ' + strDtFechaInicioBusFin + ' And TAM_FechaCreacionFormula__c <= ' + strDtFechaFinBusFin + '' +
            ' And (Status = \'BDC\')' +
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +            
            ' Group By TAM_NomPropKban__c';
        if (Test.isRunningTest())    
            queryledsCitaAsist = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsCitaAsist' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';                        
        //Todos los candidatos agrupados por ledsCitaAsist
        /*for (AggregateResult aggrCodDist : [ SELECT TAM_NomPropKban__c, COUNT(ID) totledsCitaAsist
            FROM Lead Where TAM_NomPropKban__c IN :mapNomUsrWrpsuario.keySet() And TAM_NomPropKban__c != null
            And (Status = 'BDC')
            Group By TAM_NomPropKban__c]){*/
        System.debug('EN clsBuscaTotPorUsuario queryledsCitaAsist: ' + queryledsCitaAsist);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsCitaAsist)){            
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decledsCitaAsist = (Decimal) aggrCodDist.get('totledsCitaAsist');
            System.debug('EN ledsCitaAsist sIdNomUsr: ' + sIdNomUsr + ' decledsCitaAsist: ' + decledsCitaAsist);            
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsCitaAsist = String.valueOf(decledsCitaAsist);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                '', '', '', String.valueOf(decledsCitaAsist), '', '', '', '', ''));                
        }

        String queryledsNegocia = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsNegocia' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaCreacionFormula__c >= ' + strDtFechaInicioBusFin + ' And TAM_FechaCreacionFormula__c <= ' + strDtFechaFinBusFin + '' +
            ' And (Status = \'Prueba de Manejo\' OR Status = \'Cotización\' OR Status = \'Precalificado\' OR Status = \'Solicitud\' OR Status = \'Prospecto Caliente\')' +
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +
            ' Group By TAM_NomPropKban__c';
        if (Test.isRunningTest())    
            queryledsNegocia = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsNegocia' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';            
        //Todos los candidatos agrupados por ledsNegocia
        /*for (AggregateResult aggrCodDist : [ SELECT TAM_NomPropKban__c, COUNT(ID) totledsNegocia
            FROM Lead Where TAM_NomPropKban__c IN :mapNomUsrWrpsuario.keySet() And TAM_NomPropKban__c != null
            And (Status = 'Prueba de Manejo' OR Status = 'Cotización' OR Status = 'Precalificado' OR Status = 'Solicitud' OR Status = 'Prospecto Caliente')          
            Group By TAM_NomPropKban__c]){*/
        System.debug('EN clsBuscaTotPorUsuario queryledsNegocia: ' + queryledsNegocia);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsNegocia)){            
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decledsNegocia = (Decimal) aggrCodDist.get('totledsNegocia');
            System.debug('EN ledsNegocia sIdNomUsr: ' + sIdNomUsr + ' decledsNegocia: ' + decledsNegocia);            
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsNegocia = String.valueOf(decledsNegocia);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                '', '', '', '', String.valueOf(decledsNegocia), '', '', '', ''));                
        }

        String queryledsPedido = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsPedido' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaCreacionFormula__c >= ' + strDtFechaInicioBusFin + ' And TAM_FechaCreacionFormula__c <= ' + strDtFechaFinBusFin + '' +
            ' And (Status = \'Pedido en Proceso\' OR Status = \'Facturado\')' +
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +
            ' Group By TAM_NomPropKban__c';
        if (Test.isRunningTest())    
            queryledsPedido = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsPedido' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';            
        //Todos los candidatos agrupados por ledsPedido
        /*for (AggregateResult aggrCodDist : [ SELECT TAM_NomPropKban__c, COUNT(ID) totledsPedido
            FROM Lead Where TAM_NomPropKban__c IN :mapNomUsrWrpsuario.keySet() And TAM_NomPropKban__c != null
            And (Status = 'Pedido en Proceso' OR Status = 'Facturado')          
            Group By TAM_NomPropKban__c]){*/
        System.debug('EN clsBuscaTotPorUsuario queryledsPedido: ' + queryledsPedido);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsPedido)){
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decledsPedido = (Decimal) aggrCodDist.get('totledsPedido');
            System.debug('EN ledsPedido sIdNomUsr: ' + sIdNomUsr + ' decledsPedido: ' + decledsPedido);            
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsPedido = String.valueOf(decledsPedido);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                '', '', '', '', '', String.valueOf(decledsPedido), '', '', ''));                
        }

        System.debug('EN clsBuscaTotPorUsuario strDtFechaInicioBusFinVtaF2: ' + strDtFechaInicioBusFinVta + ' strDtFechaFinBusFinVta: ' + strDtFechaFinBusFinVta);
        String queryledsVenta = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsVenta' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaEntrega__c > ' + strDtFechaInicioBusFinVta + ' And TAM_FechaEntrega__c < ' + strDtFechaFinBusFinVta + '' +
            ' And (Status = \'Entregado\')' +
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +
            ' Group By TAM_NomPropKban__c';
        if (Test.isRunningTest())    
            queryledsVenta = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsVenta' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';            
        //Todos los candidatos agrupados por ledsVenta
        /*for (AggregateResult aggrCodDist : [ SELECT TAM_NomPropKban__c, COUNT(ID) totledsVenta
            FROM Lead Where TAM_NomPropKban__c IN :mapNomUsrWrpsuario.keySet() And TAM_NomPropKban__c != null
            And (Status = 'Entregado')          
            Group By TAM_NomPropKban__c]){*/
        System.debug('EN clsBuscaTotPorUsuario queryledsVenta: ' + queryledsVenta);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsVenta)){            
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decledsVenta = (Decimal) aggrCodDist.get('totledsVenta');
            System.debug('EN ledsVenta sIdNomUsr: ' + sIdNomUsr + ' decledsVenta: ' + decledsVenta);            
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsVenta = String.valueOf(decledsVenta);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase())) 
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                '', '', '', '', '', '', String.valueOf(decledsVenta), '', ''));                
        }

        String queryledsActivos = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsActivos' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaCreacionFormula__c >= ' + strDtFechaInicioBusFin + ' And TAM_FechaCreacionFormula__c <= ' + strDtFechaFinBusFin + '' +
            ' And (Status = \'Nuevo Prospecto\' OR Status = \'Lead por contactar\' OR Status = \'Lead contactado\'' + 
            ' OR Status = \'Cita agendada\' OR Status = \'BDC\' OR Status = \'Prueba de Manejo\' OR Status = \'Cotización\'' + 
            ' OR Status = \'Precalificado\' OR Status = \'Solicitud\' OR Status = \'Prospecto Caliente\'' + 
            ' OR Status = \'Pedido en Proceso\' OR Status = \'Facturado\')' +
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +
            ' Group By TAM_NomPropKban__c';
        if (Test.isRunningTest())    
            queryledsActivos = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsActivos' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';            
        //Todos los candidatos agrupados por ledsActivos
        /*for (AggregateResult aggrCodDist : [ SELECT TAM_NomPropKban__c, COUNT(ID) totledsActivos
            FROM Lead Where TAM_NomPropKban__c IN :mapNomUsrWrpsuario.keySet() And TAM_NomPropKban__c != null
            And (Status = 'Nuevo Prospecto' OR Status = 'Lead por contactar' OR Status = 'Lead contactado' 
            OR Status = 'Cita agendada' OR Status = 'BDC' OR Status = 'Prueba de Manejo' OR Status = 'Cotización' 
            OR Status = 'Precalificado' OR Status = 'Solicitud' OR Status = 'Prospecto Caliente' 
            OR Status = 'Pedido en Proceso' OR Status = 'Facturado')
            Group By TAM_NomPropKban__c]){*/
        System.debug('EN clsBuscaTotPorUsuario queryledsActivos: ' + queryledsActivos);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsActivos)){                
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decledsActivos = (Decimal) aggrCodDist.get('totledsActivos');
            System.debug('EN ledsActivos sIdNomUsr: ' + sIdNomUsr + ' decledsActivos: ' + decledsActivos);            
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsActivos = String.valueOf(decledsActivos);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                '', '', '', '', '', '', '', String.valueOf(decledsActivos), ''));                
        }

        String queryledsBajas = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsBajas' +
            ' FROM Lead Where TAM_NomPropKban__c IN ' + sLUsersCons + 
            ' And TAM_NomPropKban__c != null And TAM_FechaBaja__c > ' + strDtFechaInicioBusFin + ' And TAM_FechaBaja__c < ' + strDtFechaFinBusFin + '' +
            ' And (Status = \'Baja de prospecto\' OR TAM_EstatusBaja__c = \'Aprobar Baja\')' +            
            ' And FWY_codigo_distribuidor__c = \'' + sCodDealerSelPrm + '\'' +
            ' Group By TAM_NomPropKban__c';
        if (Test.isRunningTest())    
            queryledsBajas = 'SELECT TAM_NomPropKban__c, COUNT(ID) totledsBajas' +
            ' FROM Lead Group By TAM_NomPropKban__c' + 
            ' LIMIT 1';            
        //Todos los candidatos agrupados por ledsBajas
        /*for (AggregateResult aggrCodDist : [ SELECT TAM_NomPropKban__c, COUNT(ID) totledsBajas
            FROM Lead Where TAM_NomPropKban__c IN :mapNomUsrWrpsuario.keySet() And TAM_NomPropKban__c != null
            And (Status = 'Baja de prospecto') Group By TAM_NomPropKban__c]){*/
        System.debug('EN clsBuscaTotPorUsuario queryledsBajas: ' + queryledsBajas);                                        
        for (AggregateResult aggrCodDist : Database.query(queryledsBajas)){            
            //Mete a un mapa el total
            String sIdNomUsr = (String) aggrCodDist.get('TAM_NomPropKban__c');
            Decimal decledsBajas = (Decimal) aggrCodDist.get('totledsBajas');
            System.debug('EN ledsBajas sIdNomUsr: ' + sIdNomUsr + ' decledsBajas: ' + decledsBajas);            
            //Actualizalo en el mapa de mapNomUsrWrpsuario
            if (mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.get(sIdNomUsr.toUpperCase()).ledsBajas = String.valueOf(decledsBajas);
            if (!mapNomUsrWrpsuario.containsKey(sIdNomUsr.toUpperCase()))
                mapNomUsrWrpsuario.put(sIdNomUsr.toUpperCase(), new wrpListaDealersUsuarios(new wrpUsuario(sCodDist, sIdNomUsr.toUpperCase(), objWrpUsuarioPrm.funcionUsuario),
                '', '', '', '', '', '', '', '', String.valueOf(decledsBajas)));                
        }

        //@AuraEnabled public wrpUsuario objWrpUsuarioAct {get;set;} 
        Integer ledsSinAtender = 0;
        Integer ledsProcCita = 0; 
        Integer ledsCitaAgenda = 0; 
        Integer ledsCitaAsist = 0; 
        Integer ledsNegocia = 0; 
        Integer ledsPedido = 0; 
        Integer ledsVenta = 0; 
        Integer ledsActivos = 0; 
        Integer ledsBajas = 0;

        //Recorre el mapa de mapNomUsrWrpsuario y llena los campos que esten vacios en 0
        for (wrpListaDealersUsuarios obWrpUsr : mapNomUsrWrpsuario.values()){
            if (obWrpUsr.ledsSinAtender == '' || obWrpUsr.ledsSinAtender == null)
                obWrpUsr.ledsSinAtender = '0';
            if (obWrpUsr.ledsSinAtender != '' && obWrpUsr.ledsSinAtender != null)
                ledsSinAtender += Integer.valueOf(obWrpUsr.ledsSinAtender);
            System.debug('EN clsBuscaTotPorUsuario ledsSinAtender: ' + ledsSinAtender);        
                
            if (obWrpUsr.ledsProcCita == '' || obWrpUsr.ledsProcCita == null)
                obWrpUsr.ledsProcCita = '0';
            if (obWrpUsr.ledsProcCita != '' && obWrpUsr.ledsProcCita != null)
                ledsProcCita += Integer.valueOf(obWrpUsr.ledsProcCita);
            System.debug('EN clsBuscaTotPorUsuario ledsProcCita: ' + ledsProcCita);        

            if (obWrpUsr.ledsCitaAgenda == '' || obWrpUsr.ledsCitaAgenda == null)
                obWrpUsr.ledsCitaAgenda = '0';
            if (obWrpUsr.ledsCitaAgenda != '' && obWrpUsr.ledsCitaAgenda != null)
                ledsCitaAgenda += Integer.valueOf(obWrpUsr.ledsCitaAgenda);
            System.debug('EN clsBuscaTotPorUsuario ledsCitaAgenda: ' + ledsCitaAgenda);        

            if (obWrpUsr.ledsCitaAsist == '' || obWrpUsr.ledsCitaAsist == null)
                obWrpUsr.ledsCitaAsist = '0';
            if (obWrpUsr.ledsCitaAsist != '' && obWrpUsr.ledsCitaAsist != null)
                ledsCitaAsist += Integer.valueOf(obWrpUsr.ledsCitaAsist);
            System.debug('EN clsBuscaTotPorUsuario ledsCitaAsist: ' + ledsCitaAsist);        

            if (obWrpUsr.ledsNegocia == '' || obWrpUsr.ledsNegocia == null)
                obWrpUsr.ledsNegocia = '0';
            if (obWrpUsr.ledsNegocia != '' && obWrpUsr.ledsNegocia != null)
                ledsNegocia += Integer.valueOf(obWrpUsr.ledsNegocia);
            System.debug('EN clsBuscaTotPorUsuario ledsNegocia: ' + ledsNegocia);        

            if (obWrpUsr.ledsPedido == '' || obWrpUsr.ledsPedido == null)
                obWrpUsr.ledsPedido = '0';
            if (obWrpUsr.ledsPedido != '' && obWrpUsr.ledsPedido != null)
                ledsPedido += Integer.valueOf(obWrpUsr.ledsPedido);
            System.debug('EN clsBuscaTotPorUsuario ledsPedido: ' + ledsPedido);        

            if (obWrpUsr.ledsVenta == '' || obWrpUsr.ledsVenta == null)
                obWrpUsr.ledsVenta = '0';
            if (obWrpUsr.ledsVenta == '' && obWrpUsr.ledsVenta == null)
                ledsVenta += Integer.valueOf(obWrpUsr.ledsVenta);
            System.debug('EN clsBuscaTotPorUsuario ledsVenta: ' + ledsVenta);        

            if (obWrpUsr.ledsActivos == '' || obWrpUsr.ledsActivos == null)
                obWrpUsr.ledsActivos = '0';
            if (obWrpUsr.ledsActivos != '' && obWrpUsr.ledsActivos != null)
                ledsActivos += Integer.valueOf(obWrpUsr.ledsActivos);
            System.debug('EN clsBuscaTotPorUsuario ledsActivos: ' + ledsActivos);        

            if (obWrpUsr.ledsBajas == '' || obWrpUsr.ledsBajas == null)
                obWrpUsr.ledsBajas = '0';
            if (obWrpUsr.ledsBajas != '' && obWrpUsr.ledsBajas != null)
                ledsBajas += Integer.valueOf(obWrpUsr.ledsBajas);
            System.debug('EN clsBuscaTotPorUsuario ledsBajas: ' + ledsBajas);        

        }//Fin del for para mapNomUsrWrpsuario.values()

        System.debug('EN clsBuscaTotPorUsuario mapNomUsrWrpsuario: ' + mapNomUsrWrpsuario.keyset());        
        System.debug('EN clsBuscaTotPorUsuario mapNomUsrWrpsuario: ' + mapNomUsrWrpsuario.values());        
        
        List<String> lProp = new List<String>();
        List<String> lPropFinal = new List<String>();
        
        //Ya tienes el mapa complto con la info que necesitas toma la lista de ges y ordenala
        for (String sNomPro : mapNomUsrWrpsuario.KeySet()){
            lProp.add(sNomPro);
        }
        //Ordena la lista de lProp
        lProp.sort();
        //Recorre la lista final y toma los nombres ordenados del mapa
        for (String sNomProp : lProp){
            //Agregalo a la lista de lWrpListaDealersUsuarios
            lWrpListaDealersUsuarios.add(mapNomUsrWrpsuario.get(sNomProp));
        }       

        //Crea el renglon de los totales TOTALES
        mapNomUsrWrpsuario.put('TOTALES', new wrpListaDealersUsuarios(new wrpUsuario('', 'TOTALES', ''),
            String.valueOf(ledsSinAtender), String.valueOf(ledsProcCita), String.valueOf(ledsCitaAgenda), 
            String.valueOf(ledsCitaAsist), String.valueOf(ledsNegocia), String.valueOf(ledsPedido), 
            String.valueOf(ledsVenta), String.valueOf(ledsActivos), String.valueOf(ledsBajas) ));
        System.debug('EN clsBuscaTotPorUsuario lWrpListaDealersUsuarios: ' + lWrpListaDealersUsuarios);        

        //Agrega el objeto de los totales a la lista de lWrpListaDealersUsuarios
        lWrpListaDealersUsuarios.add(mapNomUsrWrpsuario.get('TOTALES'));

        //Regresa la lista de Dealers
        return lWrpListaDealersUsuarios;
        
    }   
    
}